package com.sun.org.apache.xpath.internal.functions;

import com.sun.org.apache.xpath.internal.compiler.Compiler;
import com.sun.org.apache.xpath.internal.ExpressionOwner;
import com.sun.org.apache.xpath.internal.XPathVisitor;
import javax.xml.transform.TransformerException;
import com.sun.org.apache.xpath.internal.objects.XObject;
import com.sun.org.apache.xpath.internal.XPathContext;
import com.sun.org.apache.xpath.internal.res.XPATHMessages;
import com.sun.org.apache.xpath.internal.Expression;

public abstract class Function extends Expression
{
    static final long serialVersionUID = 6927661240854599768L;
    
    public Function() {
    }
    
    public void setArg(Expression arg, int argNum) throws WrongNumberArgsException {
        this.reportWrongNumberArgs();
    }
    
    public void checkNumberArgs(int argNum) throws WrongNumberArgsException {
        if (argNum != 0) {
            this.reportWrongNumberArgs();
        }
    }
    
    protected void reportWrongNumberArgs() throws WrongNumberArgsException {
        throw new WrongNumberArgsException(XPATHMessages.createXPATHMessage("zero", (Object[])null));
    }
    
    @Override
    public XObject execute(XPathContext xctxt) throws TransformerException {
        System.out.println("Error! Function.execute should not be called!");
        return null;
    }
    
    public void callArgVisitors(XPathVisitor visitor) {
    }
    
    @Override
    public void callVisitors(ExpressionOwner owner, XPathVisitor visitor) {
        if (visitor.visitFunction(owner, this)) {
            this.callArgVisitors(visitor);
        }
    }
    
    @Override
    public boolean deepEquals(Expression expr) {
        return this.isSameClass(expr);
    }
    
    public void postCompileStep(Compiler compiler) {
    }
}
